# HG changeset patch
# User Antoine Beaupré <anarcat@koumbit.org>
# Date 1414452246 14400
#      Mon Oct 27 19:24:06 2014 -0400
# Node ID 0441f2754653bb59af364056caf0cb24b6c5ef2f
# Parent  bd1d2bac911911051c0a7b7f345cb6a0eba58ea7
sort Marine VHF channels by channel number

since the order is changed, the patch changes every line but only order was modified

diff -r bd1d2bac9119 -r 0441f2754653 stock_configs/Marine VHF Channels.csv
--- a/stock_configs/Marine VHF Channels.csv	Wed Oct 22 11:10:10 2014 +0100
+++ b/stock_configs/Marine VHF Channels.csv	Mon Oct 27 19:24:06 2014 -0400
@@ -1,61 +1,61 @@
-Location,Name,Frequency,Duplex,Offset,Tone,rToneFreq,cToneFreq,DtcsCode,DtcsPolarity,Mode,TStep,Skip,Comment,URCALL,RPT1CALL,RPT2CALL
-0,MVHF  L1,155.500000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-1,MVHF  L2,155.525000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-2,MVHF  F1,155.625000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-3,MVHF  F2,155.775000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-4,MVHF  F3,155.825000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-5,MVHF K06,156.300000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-6,MVHF K67,156.375000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-7,MVHF K08,156.400000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-8,MVHF K68,156.425000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-9,MVHF K09,156.450000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-10,MVHF K69,156.475000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-11,MVHF K10,156.500000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-12,MDSC K70,156.525000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-13,MVHF K11,156.550000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-14,MVHF K71,156.575000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-15,MVHF K12,156.600000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-16,MVHF K72,156.625000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-17,MVHF K13,156.650000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-18,MVHF K73,156.675000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-19,MVHF K14,156.700000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-20,MVHF K74,156.725000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-21,MVHF K15,156.750000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-22,MVHF K16,156.800000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-23,MVHF K17,156.850000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-24,MVHF K77,156.875000,,0.000000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-25,MVHF K60,160.625000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-26,MVHF K01,160.650000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-27,MVHF K61,160.675000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-28,MVHF K02,160.700000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-29,MVHF K62,160.725000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-30,MVHF K03,160.750000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-31,MVHF K63,160.775000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-32,MVHF K04,160.800000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-33,MVHF K64,160.825000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-34,MVHF K05,160.850000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-35,MVHF K65,160.875000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-36,MVHF K66,160.925000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-37,MVHF K07,160.950000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-38,MVHF K18,161.500000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-39,MVHF K78,161.525000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-40,MVHF K19,161.550000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-41,MVHF K79,161.575000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-42,MVHF K20,161.600000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,,,,,,
-43,MVHF K80,161.625000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-44,MVHF K21,161.650000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-45,MVHF K81,161.675000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-46,MVHF K22,161.700000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-47,MVHF K82,161.725000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-48,MVHF K23,161.750000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-49,MVHF K83,161.775000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-50,MVHF K24,161.800000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-51,MVHF K84,161.825000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-52,MVHF K25,161.850000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-53,MVHF K85,161.875000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-54,MVHF K26,161.900000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-55,MVHF K86,161.925000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-56,MVHF K27,161.950000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-57,MAIS K87,161.975000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-58,MVHF K28,162.000000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
-59,MAIS K88,162.025000,-,4.600000,,88.5,88.5,023,NN,FM,25.00,S,,,,,
+Location,Name,Frequency,Duplex,Offset,Tone,rToneFreq,cToneFreq,DtcsCode,DtcsPolarity,Mode,TStep,Skip,Comment,URCALL,RPT1CALL,RPT2CALL
+1,MVHF K01,160.650000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+2,MVHF K02,160.700000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+3,MVHF K03,160.750000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+4,MVHF K04,160.800000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+5,MVHF K05,160.850000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+6,MVHF K06,156.300000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+7,MVHF K07,160.950000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+8,MVHF K08,156.400000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+9,MVHF K09,156.450000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+10,MVHF K10,156.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+11,MVHF K11,156.550000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+12,MVHF K12,156.600000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+13,MVHF K13,156.650000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+14,MVHF K14,156.700000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+15,MVHF K15,156.750000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+16,MVHF K16,156.800000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+17,MVHF K17,156.850000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+18,MVHF K18,161.500000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+19,MVHF K19,161.550000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+20,MVHF K20,161.600000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,,,,,
+21,MVHF K21,161.650000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+22,MVHF K22,161.700000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+23,MVHF K23,161.750000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+24,MVHF K24,161.800000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+25,MVHF K25,161.850000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+26,MVHF K26,161.900000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+27,MVHF K27,161.950000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+28,MVHF K28,162.000000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+29,MVHF K60,160.625000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+30,MVHF K61,160.675000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+31,MVHF K62,160.725000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+32,MVHF K63,160.775000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+33,MVHF K64,160.825000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+34,MVHF K65,160.875000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+35,MVHF K66,160.925000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+36,MVHF K67,156.375000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+37,MVHF K68,156.425000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+38,MVHF K69,156.475000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+39,MDSC K70,156.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+40,MVHF K71,156.575000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+41,MVHF K72,156.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+42,MVHF K73,156.675000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+43,MVHF K74,156.725000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+44,MVHF K77,156.875000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+45,MVHF K78,161.525000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+46,MVHF K79,161.575000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+47,MVHF K80,161.625000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+48,MVHF K81,161.675000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+49,MVHF K82,161.725000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+50,MVHF K83,161.775000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+51,MVHF K84,161.825000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+52,MVHF K85,161.875000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+53,MVHF K86,161.925000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+54,MAIS K87,161.975000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+55,MAIS K88,162.025000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+56,MVHF  F1,155.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+57,MVHF  F2,155.775000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+58,MVHF  F3,155.825000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+59,MVHF  L1,155.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+60,MVHF  L2,155.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,