# HG changeset patch
# User Antoine Beaupré <anarcat@koumbit.org>
# Date 1414454286 14400
#      Mon Oct 27 19:58:06 2014 -0400
# Node ID bd4113639351673efc00634edd4512e72cc76991
# Parent  0441f2754653bb59af364056caf0cb24b6c5ef2f
split Marine presets between US and UK

diff -r 0441f2754653 -r bd4113639351 stock_configs/Marine VHF Channels UK.csv
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/stock_configs/Marine VHF Channels UK.csv	Mon Oct 27 19:58:06 2014 -0400
@@ -0,0 +1,61 @@
+Location,Name,Frequency,Duplex,Offset,Tone,rToneFreq,cToneFreq,DtcsCode,DtcsPolarity,Mode,TStep,Skip,Comment,URCALL,RPT1CALL,RPT2CALL
+1,MVHF K01,160.650000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+2,MVHF K02,160.700000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+3,MVHF K03,160.750000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+4,MVHF K04,160.800000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+5,MVHF K05,160.850000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+6,MVHF K06,156.300000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+7,MVHF K07,160.950000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+8,MVHF K08,156.400000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+9,MVHF K09,156.450000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+10,MVHF K10,156.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+11,MVHF K11,156.550000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+12,MVHF K12,156.600000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+13,MVHF K13,156.650000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+14,MVHF K14,156.700000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+15,MVHF K15,156.750000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+16,MVHF K16,156.800000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+17,MVHF K17,156.850000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+18,MVHF K18,161.500000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+19,MVHF K19,161.550000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+20,MVHF K20,161.600000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,,,,,
+21,MVHF K21,161.650000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+22,MVHF K22,161.700000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+23,MVHF K23,161.750000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+24,MVHF K24,161.800000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+25,MVHF K25,161.850000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+26,MVHF K26,161.900000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+27,MVHF K27,161.950000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+28,MVHF K28,162.000000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+29,MVHF K60,160.625000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+30,MVHF K61,160.675000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+31,MVHF K62,160.725000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+32,MVHF K63,160.775000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+33,MVHF K64,160.825000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+34,MVHF K65,160.875000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+35,MVHF K66,160.925000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+36,MVHF K67,156.375000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+37,MVHF K68,156.425000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+38,MVHF K69,156.475000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+39,MDSC K70,156.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+40,MVHF K71,156.575000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+41,MVHF K72,156.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+42,MVHF K73,156.675000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+43,MVHF K74,156.725000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+44,MVHF K77,156.875000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+45,MVHF K78,161.525000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+46,MVHF K79,161.575000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+47,MVHF K80,161.625000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+48,MVHF K81,161.675000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+49,MVHF K82,161.725000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+50,MVHF K83,161.775000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+51,MVHF K84,161.825000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+52,MVHF K85,161.875000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+53,MVHF K86,161.925000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+54,MAIS K87,161.975000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+55,MAIS K88,162.025000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+56,MVHF  F1,155.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+57,MVHF  F2,155.775000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+58,MVHF  F3,155.825000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+59,MVHF  L1,155.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
+60,MVHF  L2,155.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
diff -r 0441f2754653 -r bd4113639351 stock_configs/Marine VHF Channels US.csv
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/stock_configs/Marine VHF Channels US.csv	Mon Oct 27 19:58:06 2014 -0400
@@ -0,0 +1,62 @@
+Location,Name,Frequency,Duplex,Offset,Tone,rToneFreq,cToneFreq,DtcsCode,DtcsPolarity,Mode,TStep,Skip,Comment,URCALL,RPT1CALL,RPT2CALL
+0,MVHF US00,156.000000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+1,MVHF US01A,156.050000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Port Operations and Commercial, VTS. Available only in New Orleans / Lower Mississippi area.,,,
+2,MVHF US02,156.100000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+3,MVHF US03,156.150000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+4,MVHF US04,156.200000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+5,MVHF US05A,156.250000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Port Operations or VTS in the Houston, New Orleans and Seattle areas.,,,
+6,MVHF US6,156.300000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,,Intership Safety,,,
+7,MVHF US07A,156.350000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial,,,
+8,MVHF US8,156.400000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial (Intership only),,,
+9,MVHF US9,156.450000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Boater Calling. Commercial and Non-Commercial.,,,
+10,MVHF US10,156.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial,,,
+11,MVHF US11,156.550000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial. VTS in selected areas.,,,
+12,MVHF US12,156.600000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations. VTS in selected areas.,,,
+13,MVHF US13,156.650000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Intership Navigation Safety (Bridge-to-bridge). Ships >20m length maintain a listening watch on this channel in US waters.,,,
+14,MVHF US14,156.700000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations. VTS in selected areas.,,,
+15,MVHF US15,156.750000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Environmental (Receive only). Used by Class C EPIRBs.,,,
+16,MVHF US16,156.800000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,International Distress, Safety and Calling. Ships required to carry radio, USCG, and most coast stations maintain a listening watch on this channel.,,,
+17,MVHF US17,156.850000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,State & local govt maritime control,,,
+18,MVHF US18A,156.900000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial,,,
+19,MVHF US19A,156.950000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial,,,
+20,MVHF US20,157.000000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,,Port Operations (duplex),,,
+21,MVHF US21A,157.050000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,U.S. Coast Guard only,,,
+22,MVHF US22A,157.100000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Coast Guard Liaison and Maritime Safety Information Broadcasts. Broadcasts announced on channel 16.,,,
+23,MVHF US23A,157.150000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,U.S. Coast Guard only,,,
+24,MVHF US24,157.200000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+25,MVHF US25,157.250000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+26,MVHF US26,157.300000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+27,MVHF US27,157.350000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+28,MVHF US28,157.400000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+60,MVHF US60,156.025000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+61,MVHF US61,156.075000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+62,MVHF US62,156.125000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+63,MVHF US63A,156.175000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Port Operations and Commercial, VTS. Available only in New Orleans / Lower Mississippi area.,,,
+64,MVHF US64,156.225000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+65,MVHF US65A,156.275000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations,,,
+66,MVHF US66A,156.325000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations,,,
+67,MVHF US67,156.375000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial. Used for Bridge-to-bridge communications in lower Mississippi River. Intership only.,,,
+68,MVHF US68,156.425000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,,Non-Commercial,,,
+69,MVHF US69,156.475000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Non-Commercial,,,
+70,MVHF US70,156.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Digital Selective Calling (voice communications not allowed),,,
+71,MVHF US71,156.575000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Non-Commercial,,,
+72,MVHF US72,156.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Non-Commercial (Intership only),,,
+73,MVHF US73,156.675000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations,,,
+74,MVHF US74,156.725000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations,,,
+75,MVHF US75,156.775000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+76,MVHF US76,156.825000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,,,,
+77,MVHF US77,156.875000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations (Intership only),,,
+78,MVHF US78A,156.925000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,Non-Commercial,,,
+79,MVHF US79A,156.975000,,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial. Non-Commercial in Great Lakes only,,,
+80,MVHF US80A,157.025000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial. Non-Commercial in Great Lakes only,,,
+81,MVHF US81A,157.075000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,U.S. Government only - Environmental protection operations.,,,
+82,MVHF US82A,157.125000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,U.S. Government only,,,
+83,MVHF US83A,157.175000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,U.S. Coast Guard only,,,
+84,MVHF US84,157.225000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+85,MVHF US85,157.275000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+86,MVHF US86,157.325000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+87,MVHF US87,157.375000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Public Correspondence (Marine Operator),,,
+88,MVHF US88A,157.425000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Commercial, Intership only.,,,
+89,MVHF USAIS 1,161.975000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Automatic Identification System (AIS),,,
+90,MVHF USAIS 2,162.025000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,S,Automatic Identification System (AIS),,,
+91,MVHF US20A,157.000000,-,0.000000,,88.5,88.5,23,NN,FM,25.00,,Port Operations,,,
diff -r 0441f2754653 -r bd4113639351 stock_configs/Marine VHF Channels.csv
--- a/stock_configs/Marine VHF Channels.csv	Mon Oct 27 19:24:06 2014 -0400
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,61 +0,0 @@
-Location,Name,Frequency,Duplex,Offset,Tone,rToneFreq,cToneFreq,DtcsCode,DtcsPolarity,Mode,TStep,Skip,Comment,URCALL,RPT1CALL,RPT2CALL
-1,MVHF K01,160.650000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-2,MVHF K02,160.700000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-3,MVHF K03,160.750000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-4,MVHF K04,160.800000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-5,MVHF K05,160.850000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-6,MVHF K06,156.300000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-7,MVHF K07,160.950000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-8,MVHF K08,156.400000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-9,MVHF K09,156.450000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-10,MVHF K10,156.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-11,MVHF K11,156.550000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-12,MVHF K12,156.600000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-13,MVHF K13,156.650000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-14,MVHF K14,156.700000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-15,MVHF K15,156.750000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-16,MVHF K16,156.800000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-17,MVHF K17,156.850000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-18,MVHF K18,161.500000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-19,MVHF K19,161.550000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-20,MVHF K20,161.600000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,,,,,
-21,MVHF K21,161.650000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-22,MVHF K22,161.700000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-23,MVHF K23,161.750000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-24,MVHF K24,161.800000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-25,MVHF K25,161.850000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-26,MVHF K26,161.900000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-27,MVHF K27,161.950000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-28,MVHF K28,162.000000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-29,MVHF K60,160.625000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-30,MVHF K61,160.675000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-31,MVHF K62,160.725000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-32,MVHF K63,160.775000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-33,MVHF K64,160.825000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-34,MVHF K65,160.875000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-35,MVHF K66,160.925000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-36,MVHF K67,156.375000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-37,MVHF K68,156.425000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-38,MVHF K69,156.475000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-39,MDSC K70,156.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-40,MVHF K71,156.575000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-41,MVHF K72,156.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-42,MVHF K73,156.675000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-43,MVHF K74,156.725000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-44,MVHF K77,156.875000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-45,MVHF K78,161.525000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-46,MVHF K79,161.575000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-47,MVHF K80,161.625000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-48,MVHF K81,161.675000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-49,MVHF K82,161.725000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-50,MVHF K83,161.775000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-51,MVHF K84,161.825000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-52,MVHF K85,161.875000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-53,MVHF K86,161.925000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-54,MAIS K87,161.975000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-55,MAIS K88,162.025000,-,4.600000,,88.5,88.5,23,NN,FM,25.00,S,,,,
-56,MVHF  F1,155.625000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-57,MVHF  F2,155.775000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-58,MVHF  F3,155.825000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-59,MVHF  L1,155.500000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,
-60,MVHF  L2,155.525000,,0.000000,,88.5,88.5,23,NN,FM,25.00,,,,,